diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 570cf3306a..f87c06a2dd 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5493,6 +5493,13 @@ main(int argc, char **argv)
 		}
 	}
 
+	if (optind < (argc-1))
+	{
+		fprintf(stderr, _("too many command-line arguments (first is \"%s\")\n"), argv[optind]);
+		fprintf(stderr, _("Try \"%s --help\" for more information.\n"), progname);
+		exit(1);
+	}
+
 	/* set default script if none */
 	if (num_scripts == 0 && !is_init_mode)
 	{
